from petsc4py.PETSc import KSP, PC, IS, Mat, Options, Viewer, Vec, LGMap
import numpy as np
from mpi4py import MPI
comm_world=MPI.COMM_WORLD

viewer = Viewer().createBinary('matrix.bin', 'r')
matrix = Mat().load(viewer)
viewer = Viewer().createBinary('IS_u.bin', 'r')
u = IS().load(viewer)
viewer = Viewer().createBinary('IS_p.bin', 'r')
p = IS().load(viewer)
viewer = Viewer().createBinary('IS_t.bin', 'r')
t = IS().load(viewer)
viewer = Viewer().createBinary('IS_up.bin', 'r')
up = IS().load(viewer)

comm = matrix.getComm()
rank = comm.rank

local = up.getLocalSize()
high = comm_world.scan(local)
low = high - local
is_ind_up = IS().createStride(local, low, 1)
lgMap = LGMap().create(is_ind_up, comm=comm)
# lgMap.view()
up.view()
u_up_local = u.embed(up, True)
u_up_local.view()
u_up = lgMap.applyIS(u_up_local)
u_up=u_up.sort()
p_up_local = p.embed(up, True)
p_up = lgMap.applyIS(p_up_local)
p_up=p_up.sort()
# p_up.view()


u.view()
up.view()
Kup = matrix.createSubMatrix(up, up)
Ku = Kup.createSubMatrix(u_up, u_up)
Ku.view()

"""
# In order to build debug test
NEQ=4*5
K = Mat().create()
K.setSizes(NEQ,NEQ)
K.setUp()
K.setPreallocationNNZ(1)
for row in range(NEQ):
    K.setValue(row, row, row+1.)

K.assemble()
u = IS().createGeneral(list(range(NEQ//2)))
p = IS().createGeneral(np.array(range(NEQ//4), dtype='int32')+2*NEQ//4)
t = IS().createGeneral(np.array(range(NEQ//4), dtype='int32')+3*NEQ//4)
up = IS().createGeneral(list(range(3*NEQ//4)))

import os.path as osp
wdir='/tmp/'
v = Viewer().createBinary(osp.join(wdir,"matrix.bin"), "w")
v.view(K)
v = Viewer().createBinary(osp.join(wdir,"IS_u.bin"), "w")
v.view(u)
v = Viewer().createBinary(osp.join(wdir,"IS_p.bin"), "w")
v.view(p)
v = Viewer().createBinary(osp.join(wdir,"IS_t.bin"), "w")
v.view(t)
v = Viewer().createBinary(osp.join(wdir,"IS_up.bin"), "w")
v.view(up)
"""